VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Fixedsys"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Timer Timer1 
      Interval        =   50
      Left            =   3600
      Top             =   2280
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const JOY_BUTTON1 As Long = &H1&
Private Const JOY_BUTTON2 As Long = &H2&
Private Const JOY_BUTTON3 As Long = &H4&
Private Const JOY_BUTTON4 As Long = &H8&

Private Const JOYERR_BASE As Long = 160&
Private Const JOYERR_NOERROR As Long = 0&
Private Const JOYERR_NOCANDO As Long = (JOYERR_BASE + 6&)
Private Const JOYERR_PARMS As Long = (JOYERR_BASE + 5&)
Private Const JOYERR_UNPLUGGED As Long = (JOYERR_BASE + 7&)

Private Const MAXPNAMELEN As Long = 32&

Private Const JOYSTICKID1 As Long = 0&
Private Const JOYSTICKID2 As Long = 1&

Private Type JOYINFO
    X As Long
    Y As Long
    Z As Long
    Buttons As Long
End Type

Private Type JOYCAPS
    wMid As Integer
    wPid As Integer
    szPname As String * MAXPNAMELEN
    wXmin As Long
    wXmax As Long
    wYmin As Long
    wYmax As Long
    wZmin As Long
    wZmax As Long
    wNumButtons As Long
    wPeriodMin As Long
    wPeriodMax As Long
End Type

Private Declare Function joyGetDevCaps Lib "winmm.dll" _
                         Alias "joyGetDevCapsA" ( _
                         ByVal id As Long, _
                         lpCaps As JOYCAPS, _
                         ByVal uSize As Long) As Long
                         
Private Declare Function joyGetNumDevs Lib "winmm.dll" () As Long

Private Declare Function joyGetPos Lib "winmm.dll" ( _
                         ByVal uJoyID As Long, _
                         pji As JOYINFO) As Long

Private Function GetJoyMax(ByVal joy As Integer, JI As JOYINFO) As Boolean
    Dim jc As JOYCAPS
    If joyGetDevCaps(joy, jc, Len(jc)) <> JOYERR_NOERROR Then
        GetJoyMax = False
    Else
        JI.X = jc.wXmax
        JI.Y = jc.wYmax
        JI.Z = jc.wZmax
        JI.Buttons = jc.wNumButtons
        GetJoyMax = True
    End If
End Function

Private Function GetJoyMin(ByVal joy As Integer, JI As JOYINFO) As Boolean
    Dim jc As JOYCAPS
    If joyGetDevCaps(joy, jc, Len(jc)) <> JOYERR_NOERROR Then
        GetJoyMin = False
    Else
        JI.X = jc.wXmin
        JI.Y = jc.wYmin
        JI.Z = jc.wZmin
        JI.Buttons = jc.wNumButtons
        GetJoyMin = True
    End If
End Function

Private Function GetJoystick(ByVal joy As Integer, JI As JOYINFO) As Boolean
    If joyGetPos(joy, JI) <> JOYERR_NOERROR Then
        GetJoystick = False
    Else
        GetJoystick = True
    End If
End Function

Private Function IsJoyPresent(Optional IsConnected As Variant) As Long
    Dim ic As Boolean
    Dim i As Long
    Dim j As Long
    Dim ret As Long
    Dim JI As JOYINFO
    ic = IIf(IsMissing(IsConnected), True, CBool(IsConnected))
    i = joyGetNumDevs
    If ic Then
        j = 0
        Do While i > 0
            i = i - 1
            If joyGetPos(i, JI) = JOYERR_NOERROR Then
                j = j + 1
            End If
        Loop
        IsJoyPresent = j
    Else
        IsJoyPresent = i
    End If
End Function

Private Sub Timer1_Timer()
    Dim JInfo As JOYINFO
    Me.Cls
    Me.Print "Joysticks ID    :" + Str$(IsJoyPresent(False))
    Me.Print "Joysticks found :" + Str$(IsJoyPresent(True))
    GetJoyMax JOYSTICKID1, JInfo
    Me.Print "Max X :" + Str$(JInfo.X)
    Me.Print "Max Y :" + Str$(JInfo.Y)
    '    Me.Print "Max Z:" + Str$(JInfo.Z)
    GetJoyMin JOYSTICKID1, JInfo
    Me.Print "Min X :" + Str$(JInfo.X)
    Me.Print "Min Y :" + Str$(JInfo.Y)
    '    Me.Print "Min Z:" + Str$(JInfo.Z)
    Me.Print "Buttons   :" + Str$(JInfo.Buttons)
    GetJoystick JOYSTICKID1, JInfo
    Me.Print "Button    :" + Str$(JInfo.Buttons)
    Me.Print "Current X :" + Str$(JInfo.X)
    Me.Print "Current Y :" + Str$(JInfo.Y)
End Sub

